# ==================================================================
# Plugins::ReviewAutoValidate - Auto Generated Install Module
#
#   Plugins::ReviewAutoValidate
#   Author  : Andrew Newby
#   Version : 1
#   Updated : Sat Dec 12 00:16:27 2009
#
# ==================================================================
#

package Plugins::ReviewAutoValidate;
# ==================================================================
use strict;
use vars  qw/$VERSION $DEBUG $NAME $META/;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use Links qw/:objects/;

$VERSION = '1';
$DEBUG   = 0;
$NAME    = 'ReviewAutoValidate';
# Inhert from base class for debug and error methods
@Plugins::ReviewAutoValidate::ISA = qw(GT::Base);

$META = {
    'author' => 'Andrew Newby',
    'description' => 'Lets you set a limit for the number of reviews a user must have validated by admin, before you treat them as a "trusted" contributer, and auto-validate their reviews',
    'license' => 'Freeware',
    'prog_ver' => '3.2.0',
    'url' => 'http://www.ultranerds.com',
    'version' => '1'
};


sub pre_install {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they install the plugin.
#
    my $inst_msg = 'Lets you set a limit for the number of reviews a user must have validated by admin, before you treat them as a "trusted" contributer, and auto-validate their reviews';

    return $inst_msg;
}

sub pre_uninstall {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they remove the plugin.
#
    my $uninst_msg = '';

    return $uninst_msg;
}

sub install {
# -----------------------------------------------------------------------------
# This function does the actual installation.  Its first argument is a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc.  The second argument is a GT::Tar object which you can use to access any
# files in your plugin module.
#
# You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::ReviewAutoValidate::error
#
    my ($mgr, $tar) = @_;
    
    $mgr->install_menu('ReviewAutoValidate', [['Readme', 'admin.cgi?do=plugin&plugin=ReviewAutoValidate&func=Readme']]);
    $mgr->install_options('ReviewAutoValidate', [['NumberOfReviewsRequired', '5', 'Set this to the number of reviews you want to manually validate (for this user), before you trust them to be a valid contributor, and have their reviews auto-validated. For example, setting ot "5" will require the user to have contributed 5 ACTIVE reviews - and any more they add, will get auto-validated.', 'SELECT', ['10','9','8','7','6','5','4','3','2','1'], ['10','9','8','7','6','5','4','3','2','1'], '']]);
    ;
    return "The plugin has been successfully installed!";
}

sub uninstall {
# -----------------------------------------------------------------------------
# This function removes the plugin.  Its first argument is also a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc. You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::ReviewAutoValidate::error
#
    my $mgr = shift;
    
    $mgr->uninstall_hooks('ReviewAutoValidate', [['review_add', 'POST', 'Plugins::ReviewAutoValidate::main', '']]);    $mgr->uninstall_menu('ReviewAutoValidate', [['Readme', 'admin.cgi?do=plugin&plugin=ReviewAutoValidate&func=Readme']]);
    $mgr->uninstall_options('ReviewAutoValidate', [['NumberOfReviewsRequired', '5', 'Set this to the number of reviews you want to manually validate (for this user), before you trust them to be a valid contributor, and have their reviews auto-validated. For example, setting ot "5" will require the user to have contributed 5 ACTIVE reviews - and any more they add, will get auto-validated.', 'SELECT', ['10','9','8','7','6','5','4','3','2','1'], ['10','9','8','7','6','5','4','3','2','1'], '']]);
    ;
    return "The plugin has been successfully removed!";
}

1;
