# ==================================================================
# Plugins::ReviewAutoValidate - Auto Generated Program Module
#
#   Plugins::ReviewAutoValidate
#   Author  : Andrew Newby
#   Version : 1
#   Updated : Dec 12 2009
#
# ==================================================================
#

package Plugins::ReviewAutoValidate;
# ==================================================================

use strict;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use Links qw/:objects/;

# Inherit from base class for debug and error methods
@Plugins::ReviewAutoValidate::ISA = qw(GT::Base);

# Your code begins here.


# PLUGIN HOOKS
# ===================================================================


# <%Plugins::ReviewAutoValidate::main%>
sub main {
# -----------------------------------------------------------------------------
# This subroutine will be called whenever the hook 'review_add' is run.  You
# should call $PLG->action(STOP) if you don't want the regular
# 'review_add' code to run, otherwise the code will continue as normal.
#

# Do something useful here

	if ($USER->{Username}) { # no point running this if they have the option for user required to off =)
	
		use Links::Plugins;
	    my $PCFG =  Links::Plugins::get_plugin_user_cfg ('ReviewAutoValidate');
		# NumberOfReviewsRequired
	
		my $review_id = $DB->table('Reviews')->select( ['MAX(ReviewID)'], { Review_Owner => $USER->{Username} } )->fetchrow;
	
		my $users_total_validated_reviews = $DB->table('Reviews')->count( { Review_Validated => "Yes", Review_Owner => $USER->{Username} } ) || 0;

#		print $IN->header;
#		print qq|$users_total_validated_reviews >= $PCFG->{NumberOfReviewsRequired} <br />|;

		# if greater, then lets validate this review..
		if ($users_total_validated_reviews >= $PCFG->{NumberOfReviewsRequired}) {


			$DB->table('Reviews')->update( { Review_Validated => "Yes" }, { ReviewID => $review_id } ) || die $GT::SQL::error;

			my $review = $DB->table('Reviews')->select( { ReviewID => $review_id, Review_Owner => $USER->{Username} } )->fetchrow_hashref;

			# Format the date
		    Links::init_date();
		    $review->{Review_Date} = GT::Date::date_transform($review->{Review_Date}, '%yyyy%-%mm%-%dd%', $CFG->{date_user_format});
			
		    if ($CFG->{email_add}) {
		        Links::send_email('review_added.eml', $review) or return Links::language('VAL_CANTEMAIL', $GT::Mail::error);
		    }

		}
		
	}	


	return;

}

# ADMIN MENU OPTIONS
# ===================================================================

sub Readme {
# -------------------------------------------------------------------
# This subroutine will be called whenever the user clicks on 'Readme' in the
# admin menu.  Remember, you need to print your own HTTP header; to do so you
# can use:
#
   print $IN->header();

print q|
<html>

<head>
<meta http-equiv="Content-Language" content="en-gb" />
<meta name="GENERATOR" content="Microsoft FrontPage 6.0" />
<meta name="ProgId" content="FrontPage.Editor.Document" />
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252" />
<title>ReviewAutoValidate Readme</title>
</head>

<style>
BODY {	BACKGROUND-COLOR: #FFFFFF;	COLOR: #000000;	FONT: 11px geneva, verdana, arial, sans-serif;	scrollbar-base-color: #000000 }
a:link		{ color: #333399; text-decoration: none }
a:visited	{ color: #333399; text-decoration: none }
a:active	{ color: #666666; text-decoration: none }
a:hover		{ color: #6699FF; text-decoration: underline }
.menu {  font: verdana, 11px sans-serif;  color: #FF6600}
font { COLOR: #666666; FONT: 11px geneva, verdana, arial, sans-serif; font-weight: normal }
table td { COLOR: #666666; FONT: 11px geneva, verdana, arial, sans-serif; font-weight: normal }
.infotext { COLOR: #000033; FONT: 10px geneva, verdana, arial, sans-serif; font-weight: normal }
.menutext { COLOR: #000033; FONT: 12px geneva, verdana, arial, sans-serif; font-weight: normal }
.footertext { COLOR: #000000; FONT: 10px arial, geneva, verdana, sans-serif; font-weight: bold }
.title { COLOR: #003366; FONT: 15px verdana, arial, sans-serif; font-weight: bold }
.contacttitle { COLOR: #000000; FONT: 13px geneva, verdana, arial, sans-serif; font-weight: bold }
.logo { 	COLOR: #000000; 	FONT: 19px verdana, geneva, verdana, arial, sans-serif; 	font-weight: bold; 	font-style: italic; 	letter-spacing: 3px; TEXT-DECORATION: none }
.slogan { COLOR: #000000;FONT: 12px geneva, verdana, arial, sans-serif;	font-weight: bold;	font-style: italic }
.formbutton { FONT: 12px arial, verdana, sans-serif }
.shadeform	{ FONT: 12px arial, verdana, sans-serif;		WIDTH: 200PX;		BORDER: #000000 1px solid}
textarea	{ FONT: 12px arial, verdana, sans-serif;		WIDTH: 550PX;		HEIGHT: 200PX;		BORDER: #000000 1px solid}
input	{ FONT: 12px arial, verdana, sans-serif; BORDER: #000000 1px solid }
select {	COLOR: #333333;		WIDTH: 200PX;		FONT: 12px geneva, verdana, arial, sans-serif}
.just {text-align: justify;}
h1 {  font: verdana;  font-size: 11px;  color: #FF6600}
h2 {  font: verdana;  font-size: 12px;  color: #FF6600;  text-decoration: underline;}
h3 {  font: verdana;  font-size: 13px;  color: #FF6600}

</style>
<body>

<p class="logo">ReviewAutoValidate Readme</p>
<p class="menu"><font face="Tahoma" size="2">[ <a href="#support">support</a> 
] [ <a href="#settingup">installing</a> ] [ <a href="#options">
plugin options</a> ]&nbsp; [ <a href="#templates">templates</a> ]</font></p>
<h2>Product details:</h2>
<p><b>Version:</b> 1.0.0<b><br />
Release Date:</b> 12th December 2009<b><br>
Author:</b> Andy Newby (<a target="_blank" href="http://www.ultranerds.com">Ultranerds.com</a>)</p>
<a name="settingup"></a><h2>Setting Up</h2>
<p>All you need to do, is edit the settings
<a target="_blank" href="admin.cgi?do=page&page=plugin_manager.html&plugin_man_do=edit_installed&plugin_name=ReviewAutoValidate">
here</a>, and update the template as explained a little further down this 
document.</p>
<hr>

<a name="advanced"></a>
<a name="req"></a><h2>Requirements</h2>
<p>The main requirements are as follows:</p>
<ol>
	<li>Gossamer Links 3.0.4+</li>
</ol>
<hr>

<a name="about"></a><h2>About</h2>
<p>Lets you set a limit for the number of reviews a user must have validated by 
admin, before you treat them as a &quot;trusted&quot; contributor, and auto-validate their 
reviews</p>
<hr>

<a name="features"></a><a name="templates">
<h2>Templates</h2></a>

<p>In <b>review_add_success.html</b>, you need to add the following (anywhere in 
the template, but probably better at the very top of it)</p>
<p>&lt;%Plugins::ReviewAutoValidate::main%&gt;</p>
<hr>

<a name="options"><h2>Plugin Options</h2></a>
<p align="left">There is only one plugin option, and you can edit it via <b>Plugins &gt; 
Plugin Manager </b>, then find <b>ReviewAutoValidate&nbsp; </b>and click <b>
[edit]</b> next to it.</p>
<hr>

<a name="support"><h2>Support</h2></a>
<p>If you need help, please bear in mind this is a free plugin, you can use either of the 
following methods to get support;</p>
<ul>
	<li>Post a message on our forum (<a target="_blank" href="http://www.ultranerds.com/forum">http://www.ultranerds.com/forum</a>) 
	</li>
	<li>Post a message on the GT forum, and we will try to deal with it ASAP:
	<a target="_blank" href="http://www.gossamer-threads.com/forum">
	http://www.gossamer-threads.com/forum</a></li>
</ul>

<p>&nbsp;</p>
<p><font face="Times New Roman">
<a target="_blank" href="http://www.ultranerds.com">Ultranerds.com</a>, All 
Rights Reserved. 2002-2009. A division of <i>PUGDOG Enterprises</i><sup> </sup></font></p>

</body>

</html>


|;

}

# Always end with a 1.
1;